searchNodes=[{"ref":"Max.html","title":"Max","type":"module","doc":"A matrix library in pure Elixir based on :array. Erlang array documentation Examples iex&gt; matrix = Max.new(5, 5, default: 2) # 5x5 matrix with default value 2 iex&gt; Max.get(matrix, {0, 0}) 2 iex&gt; matrix = Max.set(matrix, {0, 0}, 8) iex&gt; Max.get(matrix, {0, 0}) 8 Enumberable protocol Max implements the Enumerable protocol, so all Enum functions can be used: iex&gt; matrix = Max.new(10, 10, default: 8) iex&gt; Enum.max(matrix) 8 iex&gt; Enum.member?(matrix, 7) false"},{"ref":"Max.html#add/2","title":"Max.add/2","type":"function","doc":"Adds two matrices. Size of matrices must match. Examples iex&gt; matrix = Max.from_list_of_lists([ ...&gt; [0, 0, 0, 0], ...&gt; [1, 1, 1, 1], ...&gt; [2, 2, 2, 2] ...&gt;]) iex&gt; Max.add(matrix, matrix) |&gt; Max.to_list_of_lists() [ [0, 0, 0, 0], [2, 2, 2, 2], [4, 4, 4, 4] ]"},{"ref":"Max.html#argmax/1","title":"Max.argmax/1","type":"function","doc":"Returns position tuple of largest value. Examples iex&gt; matrix = Max.new(5, 5, default: 8) iex&gt; matrix |&gt; Max.argmax() {0, 0} iex&gt; matrix = matrix |&gt; Max.set({1, 1}, 10) iex&gt; matrix |&gt; Max.argmax() {1, 1}"},{"ref":"Max.html#argmin/1","title":"Max.argmin/1","type":"function","doc":"Returns position tuple of smallest value. Examples iex&gt; matrix = Max.new(5, 5, default: 8) iex&gt; matrix |&gt; Max.argmin() {0, 0} iex&gt; matrix = matrix |&gt; Max.set({1, 1}, 7) iex&gt; matrix |&gt; Max.argmin() {1, 1}"},{"ref":"Max.html#column/2","title":"Max.column/2","type":"function","doc":"Reduces matrix to only one column at given col index. Examples iex&gt; matrix = Max.new(5, 5, default: 3) iex&gt; matrix |&gt; Max.column(4) |&gt; Max.to_list_of_lists [[3], [3], [3], [3], [3]]"},{"ref":"Max.html#column_to_list/2","title":"Max.column_to_list/2","type":"function","doc":"Converts column at given column index of matrix to list. Examples iex&gt; matrix = Max.identity(5) iex&gt; matrix |&gt; Max.column_to_list(0) [1, 0, 0, 0, 0]"},{"ref":"Max.html#concat/3","title":"Max.concat/3","type":"function","doc":"Concatenates a list of matrices. Returns a new %Max{} struct with a new array containing all values of matrices from list. Options :default - (term) the default value of the matrix. Defaults to 0. Examples iex&gt; matrix = Max.new(3, 3) |&gt; Max.map(fn i, _v -&gt; i end) iex&gt; matrix |&gt; Max.to_list_of_lists() [ [0, 1, 2], [3, 4, 5], [6, 7, 8] ] iex&gt; Max.concat([matrix, matrix], :rows) |&gt; Max.to_list_of_lists() [ [0, 1, 2], [3, 4, 5], [6, 7, 8], [0, 1, 2], [3, 4, 5], [6, 7, 8] ] iex&gt; Max.concat([matrix, matrix], :columns) |&gt; Max.to_list_of_lists() [ [0, 1, 2, 0, 1, 2], [3, 4, 5, 3, 4, 5], [6, 7, 8, 6, 7, 8] ]"},{"ref":"Max.html#default/1","title":"Max.default/1","type":"function","doc":"Returns the default value for matrix. Examples iex&gt; matrix = Max.from_list_of_lists([[1,2], [3,4]]) iex&gt; matrix |&gt; Max.default() 0 iex&gt; matrix = Max.new(5, 5, default: &quot;preciz&quot;) iex&gt; matrix |&gt; Max.default() &quot;preciz&quot;"},{"ref":"Max.html#diagonal/1","title":"Max.diagonal/1","type":"function","doc":"Returns diagonal of matrix. Examples iex&gt; matrix = Max.identity(3) iex&gt; matrix |&gt; Max.to_list_of_lists() [ [1, 0, 0], [0, 1, 0], [0, 0, 1] ] iex&gt; matrix |&gt; Max.diagonal() |&gt; Max.to_list_of_lists() [[1, 1, 1]]"},{"ref":"Max.html#dot/2","title":"Max.dot/2","type":"function","doc":"Returns matrix product of the two given matrices. Number of columns of the first matrix must be equal to the number of rows of the second matrix. Examples iex&gt; matrix_a = Max.from_list_of_lists([ ...&gt; [-2, -2, -2, -2], ...&gt; [8, 8, 8, 8], ...&gt; [2, 2, 2, 2] ...&gt;]) iex&gt; matrix_b = Max.from_list_of_lists([ ...&gt; [0, 0, 0, 0], ...&gt; [1, 1, 1, 1], ...&gt; [2, 2, 2, 2], ...&gt; [3, 3, 3, 3] ...&gt;]) iex&gt; Max.dot(matrix_a, matrix_b) |&gt; Max.to_list_of_lists() [ [-12, -12, -12, -12], [48, 48, 48, 48], [12, 12, 12, 12] ]"},{"ref":"Max.html#drop_column/2","title":"Max.drop_column/2","type":"function","doc":"Drops column of matrix at given column_index. Examples iex&gt; matrix = Max.from_list_of_lists([ ...&gt; [0, 1, 2, 3, 4], ...&gt; [0, 1, 2, 3, 4], ...&gt; [0, 1, 2, 3, 4], ...&gt; [0, 1, 2, 3, 4] ...&gt; ]) iex&gt; matrix |&gt; Max.drop_column(1) |&gt; Max.to_list_of_lists() [ [0, 2, 3, 4], [0, 2, 3, 4], [0, 2, 3, 4], [0, 2, 3, 4] ]"},{"ref":"Max.html#drop_row/2","title":"Max.drop_row/2","type":"function","doc":"Drops row of matrix at given row_index. Examples iex&gt; matrix = Max.new(3, 3) |&gt; Max.map(fn i, _v -&gt; i + 1 end) iex&gt; matrix |&gt; Max.to_list_of_lists() [ [1, 2, 3], [4, 5, 6], [7, 8, 9] ] iex&gt; matrix |&gt; Max.drop_row(1) |&gt; Max.to_list_of_lists() [ [1, 2, 3], [7, 8, 9] ]"},{"ref":"Max.html#find/2","title":"Max.find/2","type":"function","doc":"Returns position of the first occurence of the given value or nil if nothing was found. Examples iex&gt; Max.new(5, 5) |&gt; Max.find(0) {0, 0} iex&gt; matrix = Max.new(5, 5) |&gt; Max.map(fn i, _v -&gt; i end) iex&gt; matrix |&gt; Max.find(16) {3, 1} iex&gt; matrix |&gt; Max.find(42) nil"},{"ref":"Max.html#flip_lr/1","title":"Max.flip_lr/1","type":"function","doc":"Flips columns of matrix in the left-right direction (vertical axis). Examples iex&gt; matrix = Max.from_list_of_lists([ ...&gt; [0, 1, 2, 3], ...&gt; [0, 1, 2, 3], ...&gt; [0, 1, 2, 3] ...&gt;]) iex&gt; matrix |&gt; Max.flip_lr() |&gt; Max.to_list_of_lists() [ [3, 2, 1, 0], [3, 2, 1, 0], [3, 2, 1, 0] ]"},{"ref":"Max.html#flip_ud/1","title":"Max.flip_ud/1","type":"function","doc":"Flip rows of matrix in the up-down direction (horizontal axis). Examples iex&gt; matrix = Max.from_list_of_lists([ ...&gt; [0, 0, 0, 0], ...&gt; [1, 1, 1, 1], ...&gt; [2, 2, 2, 2] ...&gt;]) iex&gt; matrix |&gt; Max.flip_ud() |&gt; Max.to_list_of_lists() [ [2, 2, 2, 2], [1, 1, 1, 1], [0, 0, 0, 0] ]"},{"ref":"Max.html#foldl/3","title":"Max.foldl/3","type":"function","doc":"Folds the elements using the specified function and initial accumulator value. The elements are visited in order from the lowest index to the highest. Examples iex&gt; matrix = Max.new(5, 5, default: 1) iex&gt; matrix |&gt; Max.foldl(fn _index, value, acc -&gt; value + acc end, 0) 25"},{"ref":"Max.html#foldr/3","title":"Max.foldr/3","type":"function","doc":"Folds the elements right-to-left using the specified function and initial accumulator value. The elements are visited in order from the highest index to the lowest. Examples iex&gt; matrix = Max.new(5, 5, default: 1) iex&gt; matrix |&gt; Max.foldr(fn _index, value, acc -&gt; value + acc end, 0) 25"},{"ref":"Max.html#from_list/4","title":"Max.from_list/4","type":"function","doc":"Converts a flat list to a new %Max{} struct with the given rows &amp; columns size. Options :default - (term) the default value of the matrix. Defaults to 0. Examples iex&gt; matrix = Max.from_list([1,2,3,4,5,6], 2, 3) iex&gt; matrix |&gt; Max.to_list_of_lists [[1,2,3], [4, 5, 6]]"},{"ref":"Max.html#from_list_of_lists/2","title":"Max.from_list_of_lists/2","type":"function","doc":"Converts a list of lists matrix to a new %Max{} struct. Options :default - (term) the default value of the matrix. Defaults to 0. Examples iex&gt; matrix = %Max{rows: 2, columns: 3} = Max.from_list_of_lists([[1,2,3], [4, 5, 6]]) iex&gt; matrix |&gt; Max.to_list_of_lists [[1,2,3], [4, 5, 6]]"},{"ref":"Max.html#get/2","title":"Max.get/2","type":"function","doc":"Returns value at position from the given matrix. Examples iex&gt; matrix = Max.identity(5) iex&gt; matrix |&gt; Max.get({1, 1}) 1"},{"ref":"Max.html#identity/2","title":"Max.identity/2","type":"function","doc":"Create identity square matrix of given size. Options :default - (term) the default value of the matrix. Defaults to 0. Examples iex&gt; Max.identity(5) |&gt; Max.to_list_of_lists() [ [1, 0, 0, 0, 0], [0, 1, 0, 0, 0], [0, 0, 1, 0, 0], [0, 0, 0, 1, 0], [0, 0, 0, 0, 1] ]"},{"ref":"Max.html#index_to_position/2","title":"Max.index_to_position/2","type":"function","doc":"Returns array index corresponding to the position tuple. Examples iex&gt; matrix = Max.new(10, 10) iex&gt; matrix |&gt; Max.position_to_index({1, 1}) 11 iex&gt; matrix |&gt; Max.position_to_index({0, 4}) 4"},{"ref":"Max.html#map/2","title":"Max.map/2","type":"function","doc":"Maps each element to the result of the a given fun. The given fun receives the index as first and value as the second argument. To convert index to position use index_to_position/2. Examples iex&gt; matrix = Max.new(10, 10, default: 2) iex&gt; matrix = Max.map(matrix, fn _index, value -&gt; value + 2 end) iex&gt; matrix |&gt; Max.get({0, 0}) 4"},{"ref":"Max.html#max/1","title":"Max.max/1","type":"function","doc":"Returns largest value in matrix using Kernel.max/2. Examples iex&gt; matrix = Max.new(10, 10) |&gt; Max.map(fn index, _ -&gt; index end) iex&gt; matrix |&gt; Max.max() 99"},{"ref":"Max.html#member?/2","title":"Max.member?/2","type":"function","doc":"Checks for membership of given term. Returns true if member, false otherwise. Examples iex&gt; matrix = Max.new(5, 5) |&gt; Max.map(fn i, _ -&gt; i end) iex&gt; matrix |&gt; Max.member?(6) true iex&gt; matrix |&gt; Max.member?(100) false"},{"ref":"Max.html#min/1","title":"Max.min/1","type":"function","doc":"Returns smallest value in matrix using Kernel.min/2. Examples iex&gt; matrix = Max.new(10, 10, default: 7) iex&gt; matrix |&gt; Max.min() 7"},{"ref":"Max.html#multiply/2","title":"Max.multiply/2","type":"function","doc":"Elementwise multiplication of two matrices. Examples iex&gt; matrix = Max.from_list_of_lists([ ...&gt; [0, 0, 0, 0], ...&gt; [1, 1, 1, 1], ...&gt; [2, 2, 2, 2] ...&gt;]) iex&gt; Max.multiply(matrix, matrix) |&gt; Max.to_list_of_lists() [ [0, 0, 0, 0], [1, 1, 1, 1], [4, 4, 4, 4] ]"},{"ref":"Max.html#new/3","title":"Max.new/3","type":"function","doc":"Returns a new %Max{} struct with the given rows and columns size. Options :default - (term) the default value of the matrix. Defaults to 0. Examples Max.new(10, 5) # 10 x 5 matrix Max.new(10, 5, default: 70) # 70 as a default value"},{"ref":"Max.html#position_to_index/2","title":"Max.position_to_index/2","type":"function","doc":"Returns a position tuple for the given index. :array indices are 0 based. Examples iex&gt; matrix = Max.new(5, 5) iex&gt; matrix |&gt; Max.position_to_index({0, 0}) 0 iex&gt; matrix |&gt; Max.position_to_index({1, 0}) 5"},{"ref":"Max.html#reset/2","title":"Max.reset/2","type":"function","doc":"Resets element at position to the default value. Examples iex&gt; matrix = Max.new(5, 5, default: 1) |&gt; Max.map(fn _,_ -&gt; 7 end) iex&gt; matrix |&gt; Max.get({0, 0}) 7 iex&gt; matrix |&gt; Max.reset({0, 0}) |&gt; Max.get({0, 0}) 1"},{"ref":"Max.html#reshape/3","title":"Max.reshape/3","type":"function","doc":"Reshapes matrix to the given rows &amp; columns. Examples iex&gt; matrix = Max.identity(4) iex&gt; matrix |&gt; Max.to_list_of_lists() [ [1, 0, 0, 0], [0, 1, 0, 0], [0, 0, 1, 0], [0, 0, 0, 1] ] iex&gt; matrix |&gt; Max.reshape(2, 8) |&gt; Max.to_list_of_lists() [ [1, 0, 0, 0, 0, 1, 0, 0], [0, 0, 1, 0, 0, 0, 0, 1] ]"},{"ref":"Max.html#row/2","title":"Max.row/2","type":"function","doc":"Reduces matrix to only one row at given row index. Examples iex&gt; matrix = Max.new(5, 5, default: 3) iex&gt; matrix |&gt; Max.row(4) |&gt; Max.to_list_of_lists [[3, 3, 3, 3, 3]]"},{"ref":"Max.html#row_to_list/2","title":"Max.row_to_list/2","type":"function","doc":"Converts row at given row index of matrix to list. Examples iex&gt; matrix = Max.identity(5) iex&gt; matrix |&gt; Max.row_to_list(2) [0, 0, 1, 0, 0]"},{"ref":"Max.html#set/3","title":"Max.set/3","type":"function","doc":"Sets value at position in matrix. Returns %Max{} struct. Examples iex&gt; matrix = Max.new(10, 10) iex&gt; matrix = matrix |&gt; Max.set({1, 3}, 5) iex&gt; matrix |&gt; Max.get({1, 3}) 5"},{"ref":"Max.html#set_column/3","title":"Max.set_column/3","type":"function","doc":"Set column of a matrix at column_index to the values from the given 1-column matrix. Examples iex&gt; matrix = Max.new(5, 5, default: 1) iex&gt; column_matrix = Max.new(5, 1, default: 3) iex&gt; Max.set_column(matrix, 2, column_matrix) |&gt; Max.to_list_of_lists [ [1, 1, 3, 1, 1], [1, 1, 3, 1, 1], [1, 1, 3, 1, 1], [1, 1, 3, 1, 1], [1, 1, 3, 1, 1], ]"},{"ref":"Max.html#set_row/3","title":"Max.set_row/3","type":"function","doc":"Set row of a matrix at row_index to the values from the given 1-row matrix. Examples iex&gt; matrix = Max.new(5, 5, default: 1) iex&gt; row_matrix = Max.new(1, 5, default: 3) iex&gt; Max.set_row(matrix, 2, row_matrix) |&gt; Max.to_list_of_lists() [ [1, 1, 1, 1, 1], [1, 1, 1, 1, 1], [3, 3, 3, 3, 3], [1, 1, 1, 1, 1], [1, 1, 1, 1, 1], ]"},{"ref":"Max.html#size/1","title":"Max.size/1","type":"function","doc":"Returns the size of matrix. (rows * columns) Examples iex&gt; matrix = Max.new(5, 5) iex&gt; Max.size(matrix) 25"},{"ref":"Max.html#sparse_foldl/3","title":"Max.sparse_foldl/3","type":"function","doc":"Folds the elements using the specified function and initial accumulator value, skipping default-valued entries. The elements are visited in order from the lowest index to the highest. Examples iex&gt; matrix = Max.new(5, 5, default: 1) iex&gt; matrix |&gt; Max.sparse_foldl(fn _index, value, acc -&gt; value + acc end, 0) 0"},{"ref":"Max.html#sparse_foldr/3","title":"Max.sparse_foldr/3","type":"function","doc":"Folds the array elements right-to-left using the specified function and initial accumulator value, skipping default-valued entries. The elements are visited in order from the highest index to the lowest. Examples iex&gt; matrix = Max.new(5, 5, default: 1) iex&gt; matrix |&gt; Max.sparse_foldr(fn _index, value, acc -&gt; value + acc end, 0) 0"},{"ref":"Max.html#sparse_map/2","title":"Max.sparse_map/2","type":"function","doc":"Same as map/2 except it skips default valued elements. Examples iex&gt; matrix = Max.new(10, 10, default: 2) iex&gt; matrix = Max.sparse_map(matrix, fn _index, value -&gt; value + 2 end) iex&gt; matrix |&gt; Max.get({0, 0}) # value stays at 2 because it was at default 2"},{"ref":"Max.html#sparse_size/1","title":"Max.sparse_size/1","type":"function","doc":"Returns the sparse size of the :array. Erlang array docs: &quot;Gets the number of entries in the array up until the last non-default-valued entry. That is, returns I+1 if I is the last non-default-valued entry in the array, or zero if no such entry exists.&quot; Examples iex&gt; matrix = Max.new(5, 5) iex&gt; Max.sparse_size(matrix) 0"},{"ref":"Max.html#submatrix/4","title":"Max.submatrix/4","type":"function","doc":"Returns a submatrix from the given matrix. Ranges are inclusive. Options :default - (term) the default value of the matrix. Defaults to 0. Examples iex&gt; matrix = Max.new(2, 4) |&gt; Max.map(fn i, _v -&gt; i end) iex&gt; matrix |&gt; Max.to_list_of_lists() [ [0, 1, 2, 3], [4, 5, 6, 7], ] iex&gt; matrix |&gt; Max.submatrix(0..1, 1..3) |&gt; Max.to_list_of_lists() [ [1, 2, 3], [5, 6, 7] ]"},{"ref":"Max.html#sum/1","title":"Max.sum/1","type":"function","doc":"Returns sum of integers in matrix. Examples iex&gt; matrix = Max.new(3, 3, default: 1) iex&gt; matrix |&gt; Max.sum() 9"},{"ref":"Max.html#to_list/1","title":"Max.to_list/1","type":"function","doc":"Converts matrix to a flat list. Examples iex&gt; matrix = Max.new(3, 3) |&gt; Max.map(fn index, _val -&gt; index end) iex&gt; Max.to_list(matrix) [0, 1, 2, 3, 4, 5, 6, 7, 8]"},{"ref":"Max.html#to_list_of_lists/1","title":"Max.to_list_of_lists/1","type":"function","doc":"Converts matrix to list of lists. Examples iex&gt; matrix = Max.new(5, 5) |&gt; Max.map(fn i, _v -&gt; i + 1 end) iex&gt; Max.to_list_of_lists(matrix) [ [1, 2, 3, 4, 5], [6, 7, 8, 9, 10], [11, 12, 13, 14, 15], [16, 17, 18, 19, 20], [21, 22, 23, 24, 25], ]"},{"ref":"Max.html#trace/1","title":"Max.trace/1","type":"function","doc":"Trace of matrix (sum of all diagonal elements). Examples iex&gt; matrix = Max.new(3, 3, default: 1) iex&gt; matrix |&gt; Max.trace() 3"},{"ref":"Max.html#transpose/1","title":"Max.transpose/1","type":"function","doc":"Returns transpose of given matrix. Examples iex&gt; matrix = Max.new(2, 3) |&gt; Max.map(fn i, _v -&gt; i end) iex&gt; matrix |&gt; Max.to_list_of_lists() [ [0, 1, 2], [3, 4, 5] ] iex&gt; matrix |&gt; Max.transpose() |&gt; Max.to_list_of_lists() [ [0, 3], [1, 4], [2, 5] ]"},{"ref":"Max.html#t:position/0","title":"Max.position/0","type":"type","doc":""},{"ref":"Max.html#t:t/0","title":"Max.t/0","type":"type","doc":""}]